import java.util.ArrayList;
public class Krug
{
    private Tacka c;
    private double r;
    
    private static final int neSekuSe = 1, dodirujuSe = 3;
    
    //jedinicni krug
    public Krug() {
        
        r = 1; c = new Tacka();
    }
    
    // prozvoljni krug
    public Krug(double x, double y, double r){
        
        this.r = r; c = new Tacka(x,y);
    }
    
    public Tacka dajCentar(){ return c; }
    
    public double dajPoluprecnik() { return r; }
    
    public void predstaviSe(){
    
        System.out.println("Ja sam krug sa centrom: ");
        c.predstaviSe();
        System.out.println("Moj poluprecnik je " + r);
    }
    
    public boolean sadrzi(Tacka t) {
        
        return c.rastojanjeDo(t) < r;
    }
    
    public boolean naKruznici(Tacka t) {
        
        return c.rastojanjeDo(t) == r;
    }
    
    /* 1 - ne seku se i nisu jedan u drugom
     * 2 - seku se u dve tacke,  3 - dodiruju se
     * 4 - poklapaju se, 5 - jedan sadrzi drugi
     * 6 - bas me briga
     */
    public int odnosSa(Krug k){
        
        Tacka kc = k.dajCentar();
        double kr = k.dajPoluprecnik();
        
        double d = c.rastojanjeDo(kc);
        if(d > r + kr) {
            return neSekuSe; 
        } else if (d == r + kr){
            return dodirujuSe;
        } else if(r == kr) {
            return 4;
        } else {
            return 6;
        }
    }
    
    
    public ArrayList<Tacka> unutrasnjeTacke(ArrayList<Tacka> tacke){
        
        ArrayList<Tacka> unutrasnje = new ArrayList<>();  
        for(Tacka t : tacke){
            if(sadrzi(t)){
                unutrasnje.add(t);    
            }
        }
        return unutrasnje;
    }
    
    public void test() {
        
        ArrayList<Tacka> tacke = new ArrayList<>();
        Tacka O = new Tacka(); Tacka A = new Tacka(1,1);
        Tacka B = new Tacka(-1,-1); Tacka C = new Tacka(10,10);
        tacke.add(O); tacke.add(A); tacke.add(B); tacke.add(C);
        
        ArrayList<Tacka> rezultat = unutrasnjeTacke(tacke);
        for(Tacka t : rezultat) {
            t.predstaviSe();
        }
    }
   
    public void test2(int n) {
        
        ArrayList<Tacka> tacke = new ArrayList<>();
        for(int i = 0; i < n; i++) {
            tacke.add(new Tacka(i,i));
        }
        
        ArrayList<Tacka> rezultat = unutrasnjeTacke(tacke);
        for(Tacka t : rezultat) {
            t.predstaviSe();
        }
    }
    
    public Tacka najdaljaTacka(ArrayList<Tacka> tacke){
    
        if(tacke.size() == 0) {
            return null;
        }
        
        Tacka najdalja = tacke.get(0); 
        double maxd = c.rastojanjeDo(najdalja);
        
        for(Tacka t : tacke){
            double d = c.rastojanjeDo(t);
            if(d > maxd) {
               maxd = d;
               najdalja = t;
            }
        }
        return najdalja;
    }
    
    public void test3(int n) {
        
        ArrayList<Tacka> tacke = new ArrayList<>();
        /*
        for(int i = 0; i < n; i++) {
            tacke.add(new Tacka(i,i));
        }*/
        
        Tacka t = najdaljaTacka(tacke);
        if(t == null) {
            System.out.println("Nije bilo tacaka");
        } else {
            t.predstaviSe();
        }
    }
    
    
}
